
Dialog = class("Dialog")

function Dialog:init()
    self.text = nil
    self.reveal = 0
    self.revealTimer = 0
    self.open = false

    self.lastSound = 0
end

function Dialog:update(dt)
    if self.text ~= nil then
        self.revealTimer = self.revealTimer+dt
        while self.revealTimer>=.04 and self.reveal < string.len(self.text) do
            self.revealTimer = self.revealTimer-.04
            self.reveal = self.reveal+1
            if string.sub(self.text, self.reveal, self.reveal) == ";" then
                self.revealTimer = -.3
            elseif self.reveal%2==0 then
                if love.timer.getTime()-self.lastSound>0.04 then
                    audio:play("talk")
                    self.lastSound = love.timer.getTime()
                end
            end
        end
        if self.reveal > string.len(self.text) then
            self.reveal = string.len(self.text)
        end

        if love.keyboard.isDown("space") and self.reveal >= string.len(self.text) then
            self.open = false
            self.text = nil
            audio:play("lock")
        end
    end
end

function Dialog:show(text)
    self.open = true
    self.text = text
    self.reveal = 0
end

function Dialog:draw()
    if not self.open then return end

    local x = game.player.x - game.camera.x + GAME_WIDTH/2
    local y = game.player.y - game.camera.y + GAME_HEIGHT/2
    y = y-140

    love.graphics.draw(sprites:get("speech"), x, y, 0, 2, 2, 64, 96/2)

    love.graphics.setColor(0, 0, 0, 255)
    local sx = x-115
    local sy = y-80

    local str = string.sub(self.text, 1, self.reveal):gsub(";","")
    love.graphics.print(str, math.floor(sx), math.floor(sy))


    if self.reveal>= string.len(self.text) then
        love.graphics.setColor(50, 50, 50, 255)
        love.graphics.print("Press space to continue...", math.floor(sx), math.floor(sy - math.sin(love.timer.getTime()*6)*3)+110)
    end

    love.graphics.setColor(255, 255, 255, 255)

end
