
Entity = class("Entity")

Entity.x = 0
Entity.y = 0
Entity.z = 0
Entity.depth = 0
Entity.remove = false
Entity.rotation = 0
Entity.front = false
Entity.flat = false
Entity.alpha = 255

function Entity:init(x, y, rot)
    self.x = x
    self.y = y
    self.rotation = rot or 0
end

function Entity:calculateDepth()
    local ox = GAME_WIDTH/2 - game.camera.x
    local oy = GAME_HEIGHT/2 - game.camera.y
    local y = (self.x - ox) * game.camera.sin + (self.y - oy) * game.camera.cos
    self.depth = y
end

function Entity:collision(ent)

end

function Entity:setRotation(rot)
    self.rotation = rot or 0
    if self.physics~=nil then
        self.physics.body:setAngle(rot or 0)
    end
end

function Entity:destroy()
    if self.physics~=nil then
        self.physics:destroy()
    end
end

function Entity:update(dt)

end

function Entity:draw()
    if self.alpha<255 then
        love.graphics.setColor(255, 255, 255, self.alpha)
    end
    if self.model ~= nil then
        self.model:draw(self.x-game.camera.sin*self.z, self.y-game.camera.cos*self.z, self.rotation)
    elseif self.sprite ~= nil then
        local spr = sprites:get(self.sprite)
        love.graphics.draw(spr, self.x, self.y, self.flat and 0 or -game.camera.rotation, 1, 1, spr:getWidth()/2, self.flat and spr:getHeight()/2 or spr:getHeight())
    else
        love.graphics.draw(sprites:get("box"), self.x, self.y, -game.camera.rotation, 1, 1, 10, 100)
    end
    love.graphics.setColor(255, 255, 255, 255)
end
