

FenceDoor = Entity:extend("FenceDoor")

function FenceDoor:init(x,y, rot)
    self.model = Model:new("fence_door", 64, 32)
    self.x = x
    self.y = y

    self.physics = Physics:new(self.x, self.y, "dynamic", 32, 8)
    self.physics.body:setAngle(rot)

    self.physics.body:setAngularDamping(16)

    local hinge = {}
    hinge.body = love.physics.newBody(game.world.world, self.x, self.y+32-8, "static")
    hinge.shape = love.physics.newRectangleShape(8,8)
    hinge.fixture = love.physics.newFixture(hinge.body, hinge.shape)
    self.joint = love.physics.newRevoluteJoint(hinge.body, self.physics.body, self.x+4, self.y+32, false)

    self.physics.body:setFixedRotation(true)

    self.trigger = PlayerTrigger:new(self.x, self.y-16, 16, 64)
    self.trigger.trigger = function()
        if game.player.carry and game.player.carry.name=="Key" then
            self.physics.body:setFixedRotation(false)
            game.player.carry.remove = true
            game.player.carry = false
            game.weather.intensity = 3

            game.dialog:show("\n\n\nThe storm is almost here!;\n\nI can't stay out here for too long!!;  ")
            audio:play("open")
        end
    end

end

function FenceDoor:update(dt)
    self.physics:updatePosition(self)
    self.trigger:update(dt)
end
