require "entities/player_trigger"
require "entities/entity"
require "entities/minor/fire"
require "model"

FirePlace = Entity:extend("FirePlace")

function FirePlace:init(x, y)

    self.model = Model:new("fireplace", 32)
    self.x = x
    self.y = y

    self.physics = Physics:new(self.x, self.y, "static", 20, 20)

    self.trigger = PlayerTrigger:new(self.x-20, self.y-20, 40, 40)

    self.trigger.trigger = function()
        if self.wood<3 and game.player.carry and game.player.carry.name=="Logs" then
            game.player.carry.remove = true
            self.wood = self.wood+1
            audio:play("fireplace")

            if self.wood == 3 then
                game.entities:add(Fire:new(self.x-6, self.y+9))
                --Light:
                ent = Entity:new(self.x, self.y)
                ent.sprite = "red_light"
                ent.front = true
                ent.flat = true
                ent.alpha = 100

                game.entities:add(ent)
                game.progress.fire = true

                game.weather.intensity = 2

                game.dialog:show("Finally some heat! I can\nbarely feel my feet anymore.\n\nThe weather seems to be\ngetting worse though...\n\nI can't get stuck in here during\nthe storm without food!;  ")
                
                flux.to(game.camera, 2, {rotation = math.rad(90)})
                game.player.index = 1
            end

            game.player.carry = false
        end
    end

    self.wood = 0


end

function FirePlace:update(dt)
    self.trigger:update(dt)
end
