
require "entities/pickup"
require "entities/entity"
require "model"

Key = Pickup:extend("Key")

function Key:init(x,y)
    self.x = x
    self.y = y
    self.model = Model:new("key", 16, 8)
    self.model.spacing = .75
end

function Key:update(dt)
    if not game.progress.fire then return end

    Pickup.update(self, dt)
end

function Key:pickup()
    audio:play("key")
end

function Key:draw()
    if not game.progress.fire then return end

    Entity.draw(self)
end
