
Physics = class("Physics")

function Physics:init(x, y, type, w, h)

    self.body = love.physics.newBody(game.world.world, x, y, type or "dynamic")

    if w=="circle" then
        self.shape = love.physics.newCircleShape(h)
    else
        self.shape = love.physics.newRectangleShape(w, h)
    end

    self.fixture = love.physics.newFixture(self.body, self.shape)

    self.body:setAngularDamping(1)
    self.body:setLinearDamping(2)

    self.fixture:setCategory(1)

end

function Physics:setEntity(ent)
    self.fixture:setUserData(ent)
end

function Physics:destroy()
    self.body:destroy()
end

function Physics:setSpeed(x, y)
    self.body:setLinearVelocity(x,y)
end

function Physics:updatePosition(ent)
    ent.x, ent.y = self.body:getPosition()

    if not game.world.edit then
        ent.rotation = self.body:getAngle()
    end
end
