
Roof = Entity:extend("Roof")

function Roof:init(x,y)
    self.x = x+16
    self.y = y

    self.front = true

    self.trigger = PlayerTrigger:new(self.x-340/2, self.y-224/2, 340, 224)

end

function Roof:update(dt)
    self.trigger:update(dt)

    if self.trigger.hasPlayer then
        self.alpha = self.alpha-dt*4
    else
        self.alpha = self.alpha+dt*4
    end

    if self.alpha>1 then self.alpha = 1 end
    if self.alpha<.05 then self.alpha = .05 end

end

function Roof:draw()
    local spr = sprites:get("roof")

    for i=1,5 do
        local scale = 1 - i*(.1) + .1
        love.graphics.setColor(20+i*10, 12+i*9, 5+i*7, 255*self.alpha)
        love.graphics.draw(spr, self.x - game.camera.sin*5*(i-1+6), self.y - game.camera.cos*5*(i-1+6), 0, scale, scale, spr:getWidth()/2, spr:getHeight()/2)
    end

    love.graphics.setColor(255, 255, 255, 255)
end
