
GameOver = class("GameOver")

GameOver.alpha1 = 0
GameOver.alpha2 = 0
GameOver.alpha3 = 0
GameOver.alpha4 = 0

function GameOver:init(start)
    if start=="pause" then
        self.pause = true
        self.alpha1 = 1
    elseif start then
        self.start = true
        flux.to(self, 2, {alpha1=1}):delay(1)
    else
        flux.to(self, 4, {alpha1=1}):delay(1)
        flux.to(self, 2, {alpha2=1}):delay(3)
        flux.to(self, 3, {alpha3=1}):delay(5)
        flux.to(self, 1, {alpha4=1}):delay(7)
    end
end

function GameOver:update()

    if (self.pause or self.start or self.alpha4>.7) and love.keyboard.isDown("space") then

        if self.pause then
            game.gameOver = nil
            audio:play("open")
        elseif not self.start then
            if game.wind~=nil then game.wind:stop() end
            game = Game:new()
            game:start()
            audio:play("open")
        else
            game.gameOver = nil
            game:start()
        end
        audio.volume = 0
        flux.to(audio, 2, {volume=1}):delay(.5)
        music:setVolume(0)
        music:play()
    end

end

function GameOver:draw()

    love.graphics.setFont(font2)
    love.graphics.setColor(255, 255, 255, 255*self.alpha1)
    local str = "The Cold Cabin"

    if self.start or self.pause then
        love.graphics.setColor(120, 120, 120, 255*self.alpha1)
        str = self.start and "Press space to play!" or "Press space to resume!"
        love.graphics.print(str, GAME_WIDTH/2-font2:getWidth(str)/2, GAME_HEIGHT/2+ math.cos(love.timer.getTime()*4)*6)
        love.graphics.setFont(font)
        love.graphics.setColor(255, 255, 255, 255)
        return
    end

    love.graphics.print(str, GAME_WIDTH/2-font2:getWidth(str)/2, GAME_HEIGHT/4)
    str = "Made in 48h"
    love.graphics.setColor(255, 255, 255, 255*self.alpha2)
    love.graphics.print(str, GAME_WIDTH/2-font2:getWidth(str)/2, GAME_HEIGHT/4+30)

    str = "Created by evgiz.net"
    love.graphics.setColor(255, 255, 255, 255*self.alpha3)
    love.graphics.print(str, GAME_WIDTH/2-font2:getWidth(str)/2, GAME_HEIGHT/2)

    str = "Press space to play again"
    if self.start then str = "Press space to begin!" end
    love.graphics.setColor(120, 120, 120, 255*self.alpha4)
    love.graphics.print(str, GAME_WIDTH/2-font2:getWidth(str)/2, GAME_HEIGHT/4*3 + math.cos(love.timer.getTime()*4)*6)
    love.graphics.setFont(font)

    love.graphics.setColor(255, 255, 255, 255)
end
