
class = require "libraries/30log"
util = require "libraries/util"
flux = require "libraries/flux"

--require "libraries/autobatch"

require "game"
require "sprites"
require "audio"

GAME_WIDTH = love.graphics.getWidth()
GAME_HEIGHT = love.graphics.getHeight()

local canvas


--Profiling:
local updateTimer = 0
 profile1 = 0
 profile2 = 0
local p1 = 0
local p2 = 0
---

function love.load(arg)

    music = love.audio.newSource("assets/audio/music.ogg", "stream")
    music:setLooping(true)

    love.filesystem.setIdentity("LD37", true)
    font = love.graphics.newFont("assets/font/arial.ttf", 8)
    font2 = love.graphics.newFont("assets/font/arial.ttf", 16)
    font:setFilter("nearest", "nearest")
    love.graphics.setFont(font)

    sprites = Sprites:new()
    game = Game:new()

    canvas = love.graphics.newCanvas(GAME_WIDTH, GAME_HEIGHT)
    --gameShader = love.graphics.newShader("assets/shaders/game.glsl")
end

local hasFocus = true
function love.focus(focus)
    hasFocus = focus

    if not focus and game.gameOver==nil then
        game.gameOver = GameOver:new("pause")
        music:stop()
    end
end

function love.wheelmoved(x, y)
    game.world:wheel(y)
end

function love.keypressed(key, scancode, isrepeat)
    if key=="m" then
        if audio.volume==1 then
            audio.volume = 0
            music:setVolume(0)
        else
            audio.volume = 1
            music:setVolume(1)
        end
    end

    if game.lock~=nil then
        local numb = nil
        if key=="1" then numb=1 end
        if key=="2" then numb=2 end
        if key=="3" then numb=3 end
        if key=="4" then numb=4 end
        if key=="5" then numb=5 end
        if key=="6" then numb=6 end
        if key=="7" then numb=7 end
        if key=="8" then numb=8 end
        if key=="9" then numb=9 end
        if key=="0" then numb=0 end

        if numb~=nil then

            if game.lock.step == 1 then
                game.lock.numb1 = numb
            elseif game.lock.step == 2 then
                game.lock.numb2 = numb
            elseif game.lock.step == 3 then
                game.lock.numb3 = numb
            end

            game.lock.step = game.lock.step+1
            if game.lock.step>3 then game.lock.step = 1 end

            audio:play("lock")
        end
    end

end

function love.update(dt)
    if not hasFocus then return end

    dt = math.min(dt, 1/15)

    flux.update(dt)
    music:setVolume(audio.volume)
    game:update(dt)

    if game.gameOver==nil then
        --gameShader:send("gametime", love.timer.getTime())
        --gameShader:send("intensity", game.weather.intensity)
    end


        updateTimer = updateTimer+dt
        if updateTimer>=1 then
            p1 = math.floor(profile1/updateTimer*1000)
            p2 = math.floor(profile2/updateTimer*1000)
            updateTimer = 0
            profile1, profile2 = 0,0
        end
end

function love.draw()
    love.graphics.setCanvas(canvas)

    local s = love.timer.getTime()
    game:draw()

    love.graphics.setCanvas()
    --love.graphics.setShader(gameShader)
    love.graphics.draw(canvas, 0, 0)
    love.graphics.setShader()

    game:drawUI()
    profile2 = profile2 + love.timer.getTime()-s


    if love.keyboard.isDown("f") then
        love.graphics.setColor(0, 0, 0, 255)
        love.graphics.print("FPS: "..love.timer.getFPS(), 10, GAME_HEIGHT-18)
        love.graphics.setColor(255, 255, 255, 255)
    end

    --love.graphics.print("P1: "..p1.." - P2: "..p2, 10, GAME_HEIGHT-18)
end
