
Model = class("Model")

function Model:init(name, w, h)
    self.image = sprites:get(name)

    self.width = w or 32
    self.height = h or w or 32

    self.spacing = 3

    self.quads = {}
    for i=0,math.floor(self.image:getWidth()/self.width) do
        self.quads[i+1] = love.graphics.newQuad(i*self.width, 0, self.width, self.height, self.image:getWidth(), self.image:getHeight())
    end

    self.spritebatch = love.graphics.newSpriteBatch(sprites:get(name), 15, "dynamic")

    self.drawRot = -1
    self.drawstep = 0
    self.lastRot = 0
end

function Model:draw(x, y, rot)
    if self.lastRot~=rot or self.drawstep<=3 or self.drawRot~=game.camera.rotation then
        self.drawRot = game.camera.rotation
        self.lastRot = rot
        self.drawstep = math.min(4, self.drawstep+1)
        self.spritebatch:clear()
        for i=1,#self.quads do
            self.spritebatch:add(self.quads[i], x - game.camera.sin*self.spacing*(i-1), y - game.camera.cos*self.spacing*(i-1), rot, 1, 1, self.width/2, self.height/2)
        end
    end
    love.graphics.draw(self.spritebatch)
end
