

Weather = class("Weather")

Weather.particles = {}
Weather.pool = {}

local spawn = {
    1,2,3,5,5
}
local xspeed = {
    .5,2.5,6,10,15
}
local scale = {
    1,1.5,2.4,3,4
}

function Weather:init()
    self.quads = {}

    for i=0,3 do
        self.quads[i] = love.graphics.newQuad(i*8, 0, 8, 8, 8*4, 8)
    end

    self.addTimer = 0
    self.intensity = 1
end

function Weather:addParticle(p)
    local part = p or {}
    part.x = love.math.random(-GAME_WIDTH, GAME_WIDTH)
    part.y = love.math.random(-20,-8)
    part.speed = love.math.random(80,120)/100
    part.img = love.math.random(0,3)
    part.remove = false
    part.rotation = math.deg(love.math.random(0,360))

    table.insert(self.particles, part)
end

function Weather:update(dt)
    self.addTimer = self.addTimer+dt*spawn[self.intensity]

    while self.addTimer>.01 do
        self.addTimer = self.addTimer-.01

        if #self.pool>0 then
            self:addParticle(self.pool[1])
            table.remove(self.pool, 1)
        else
            self:addParticle()
        end
    end

    speedx = 100*xspeed[self.intensity]
    speedy = 150 + xspeed[self.intensity]*70
    for i=1,#self.particles do
        local part = self.particles[i]
        if part==nil then break end
        part.x = part.x + speedx*part.speed*dt*math.max(game.camera.cos, game.camera.sin)
        part.y = part.y + speedy*part.speed*dt
        part.rotation = part.rotation+dt

        if part.y>GAME_HEIGHT+8 then
            table.remove(self.particles, i)
            table.insert(self.pool, part)
            i = i-1
        end

    end
end

function Weather:draw()
    local spr = sprites:get("snow")
    local part
    for i=1,#self.particles do
        part = self.particles[i]
        love.graphics.draw(spr, self.quads[part.img], part.x, part.y, part.rotation, scale[self.intensity], scale[self.intensity], 4, 4)
    end
end
